Subject: bug#59032: CC Mode 5.35.1 (C/*l); Incorrect fontification of `subsurface' during typing

From: Po Lu <[email-masked]>
Date: Tue, 08 Nov 2022 08:25:31 +0800

Alan Mackenzie <[email-masked]> writes:

> Hello, Po.
>
> Thanks for yet another bug.
>
> On Sat, Nov 05, 2022 at 09:34:41 +0800, Po Lu via CC-Mode-help wrote:
>> Package: cc-mode
>
>> Start with the following code in a c-mode buffer:
>
>> static struct test_subsurface *
>> make_test_subsurface (void)
>> {
>>   struct test_subsurface *subsurface;
>
>>   subsurface = malloc (sizeof *subsurface);
>
>>   if (!subsurface)
>>     goto error_1;
>
>>   subsurface->surface
>>     = wl_compositor_create_surface (display->compositor);
>
>>   if (!subsurface->surface)
>>     goto error_2;
>
>>   subsurface->subsurface
>>     = wl_subcompositor_get_subsurface (subcompositor,
>> 				       wayland_surface,
>> 				       display->surface);
>   
>>  error_2:
>>   free (subsurface);
>>  error_1:
>>   return NULL;
>> }
>
>> move point to the end of the line before "error_2".  Type:
>
>>   s u b s u r f a c e - >
>
>> then, hesitate for 1 second, and type:
>
>>   <backspace> <backspace>
>
>> wait 1 more second, then type:
>
>>   <up>
>
>> every occurrence of "subsurface" above will become fontified as a type,
>> and will be stuck that way until you make an edit above that occurrence.
>
> I have a fix for this, I think, but it overlaps with an earlier fix to
> bug #58883.  I sent you a patch on Sunday 2022-10-30 for this earlier
> bug.  Did you get this patch?  If so, have you any reaction to it?

I think it got lost in the bulk mail folder (but I can't find it there
either, so maybe a mailer screwup?)

So would you please send it again?  TIA.